<?php

superflush();
//Version d'origine : 5.0.x
//Version cible : 5.1.0
//
//
//Pour création de tables MYISAM
$enginemysql=get_enginemysql();

print "<br />";


//___________________________________________________________________

//   Champ stockant les disciplines validatrices supprimé
//___________________________________________________________________

if (champ_dans_table('disc_valid','resultats',$db)) {
    query("ALTER TABLE `resultats` DROP disc_valid");
    }


//___________________________________________________________________

//   Champ stockant le type de feuille de position
//___________________________________________________________________

//   Champ stockant le format de l'attestation'
//___________________________________________________________________



if (!champ_dans_table('fposition','etablissements',$db)) {
    query("ALTER TABLE `etablissements` ADD fposition TINYINT DEFAULT 1 NOT NULL");
    print "Ajout dans la table 'etablissements'des champs '<b>fpostion</b>' et '<b>attestation</b>' pour mémoriser choix<br>";
    }

if (!champ_dans_table('attestation','etablissements',$db)) {
    query("ALTER TABLE `etablissements` ADD `attestation` VARCHAR( 2 ) DEFAULT 'A5' NOT NULL");
    }


//___________________________________________________________________

//pour faciliter les big requêtes
//___________________________________________________________________
if (!champ_dans_table('obtenue','demandes',$db)) {
    query("
        ALTER TABLE `demandes` 
        ADD `obtenue` TINYINT NULL AFTER `commentaire` ,
        ADD `active` TINYINT NULL AFTER `obtenue` ,
        ADD `nboui` TINYINT NULL AFTER `active` ,
        ADD `nbnon` TINYINT NULL AFTER `nboui` ,
        ADD `longue` TINYINT NULL AFTER `nbnon`");
    print "Ajout de champs dans la table demandes (<b>obtenue</b>, <b>active</b>, <b>nboui</b>, <b>nbnon</b>, <b>longue</b>)<br>";
    }

    
//___________________________________________________________________
//INE élève et, dans la foulée, futur (?) identifiant prof
if (!champ_dans_table('uid','eleves',$db)) {
    query("
        ALTER TABLE `eleves` ADD uid VARCHAR(20) NOT NULL DEFAULT '' AFTER `ident_nat`");
    query("
        ALTER TABLE `profs` ADD uid VARCHAR(20) NOT NULL DEFAULT '' AFTER `ident_nat`");
    print "Ajout du champ '<b>uid</b>' dans les tables tables eleves et profs<br />";
    }

//___________________________________________________________________

//pour conserver toutes les connexions (recherche d'usurpation d'identité)
//___________________________________________________________________

if (!table_dans_base('connexions',$db)) {
	query("CREATE TABLE connexions (
			    quand DATETIME,
			    ip INTEGER,
			    machinecliente VARCHAR(255),
			    compte_id INTEGER
				) $enginemysql ");
	}

//___________________________________________________________________

//pour les mises à jour automatiques    
//___________________________________________________________________

if (!mysql_num_rows(query("SELECT * FROM _params_globaux WHERE param_nom='HTTP_INI'"))) {
    query("INSERT INTO `_params_globaux` VALUES ('HTTP_INI', 's', 'http://carlo.ac-bordeaux.fr/gibii/.meta/maj_gibii.ini', 'chemin complet du fichier .maj_gibii.ini décrivant les maj auto', -1)");
    }
if (!mysql_num_rows(query("SELECT * FROM _params_globaux WHERE param_nom='HTTP_MAJ'"))) {
    query("INSERT INTO `_params_globaux` VALUES ('HTTP_MAJ', 's', 'http://carlo.ac-bordeaux.fr/gibii', 'chemin complet du répertoire des maj (sans /)', -1)");
    print "<br>Ajout des champs pour les mises à jour automatiques dans _params_globaux<br>";
    }
if (!mysql_num_rows(query("SELECT * FROM _params_globaux WHERE param_nom='HTTP_LAST'"))) {
    query("INSERT INTO `_params_globaux` VALUES ('HTTP_LAST', 's', '0000-00-00 00:00:00', 'date de la dernière mise à jour', -1)");
    }
if (!mysql_num_rows(query("SELECT * FROM _params_globaux WHERE param_nom='HTTP_FREQ_MAJ'"))) {
    query("INSERT INTO _params_globaux VALUES ('HTTP_FREQ_MAJ', 'i', 2, 'fréquence max en jours des requêtes au serveur', 0)");
    }


//___________________________________________________________________

// Valeur par défaut de typauth_id 
//___________________________________________________________________

query("ALTER TABLE `etablissements` CHANGE `typauth_id` `typauth_id` INT( 11 ) DEFAULT '1' NOT NULL");
query("UPDATE etablissements SET typauth_id=3 WHERE typauth_id=0");

// Champs ajoutés pour thèmes perso
//___________________________________________________________________

if (!champ_dans_table('theme','comptes',$db)) {
    print "Ajout du champ '<b>theme</b>' dans la table comptes<br />";
    query("ALTER TABLE `comptes` ADD `theme` VARCHAR( 128 ) DEFAULT 'standard' NOT NULL AFTER `statut`");
    }
     

if (!champ_dans_table('chgt_theme','etablissements',$db)) {
    print "Ajout du champ '<b>chgt_theme</b>' dans la table 'etablissements'<br />";
    query("ALTER TABLE `etablissements` ADD `chgt_theme` tinyint(4) DEFAULT '0' NOT NULL AFTER `theme`");
    }

if (!champ_dans_table('theme_eleve_limite','etablissements',$db)) {
    print "Ajout du champ '<b>theme_eleve_limite</b>' dans la table 'etablissements'<br />";
    query("ALTER TABLE `etablissements` ADD `theme_eleve_limite` tinyint(4) DEFAULT '0' NOT NULL AFTER `chgt_theme`");
    }
      
superflush();

//INE à géométrie variable
//___________________________________________________________________
query("REPLACE INTO _params_globaux SET  param_nom='ADM_INE',
                    param_type='i' ,
                    param_val=0 ,
                    param_desc='Les admins peuvent lire modifier l INE eleve'");
                    
query("REPLACE INTO _params_globaux VALUES ('STATSPROFS', 'i', '0', 'Accès aux stats nominatives par professeur en sadmin', 0)");                    

//Correction libellé C.1.3
query("UPDATE `libelles` SET `base` = 'C.1.3 Je sais organiser mes espaces de stockage.' WHERE `item_id` =25 LIMIT 1");
query("UPDATE `libelles` SET `base` = 'L.1.3 Je sais régler les principaux paramètres de fonctionnement d\'un périphérique selon mes besoins.' WHERE `item_id` =54 LIMIT 1");
query("UPDATE `libelles` SET `inst` = 'L.1.3 Je sais régler les principaux paramètres de fonctionnement d\'un périphérique selon mes besoins.' WHERE `item_id` =54 LIMIT 1");

//Corrections de base de 5.0 à 5.0.12
query("UPDATE libelles SET base='L.1.5 Je sais m\affranchir des fonctions automatiques des logiciels (saisie, mémorisation mot de passe, correction orthographique, incrémentation)' WHERE item_id=56");
query("UPDATE _params_globaux SET param_type = 's' WHERE param_nom='LAST_PROC_GLOBAL'"); 



?>