<?php
//Remplissage des nouveaux champs de la table demandes
//(passage de 5.0 à 5.1)	

//==========================================================================
//Mettre en global les variables utilisées au plus haut niveau de ce script
//car il se retrouve dans la fonction lancer_maj() par le include des maj

global  $message_id, 
		$eleve_id,$item_id,$disc_id,$age,
		$active,$obtenue,$nboui,$nbnon,$longue,
		$taccord,
		$nbj_vie_demande,$nb_validations,$nb_max_refus,$profslongs;
//$MODULE est déjà en global dans la fonction incluante lancer_maj()
//==========================================================================

superflush();


set_time_limit(0);




function parla($endroit) {
print "<br><b>$endroit</b><br>";
}	
	
function purge_demrep($liste) {
$t=array_chunk($liste,100);
foreach($t as $tpart) {
	//print_r($tpart);
	$lpart=implode(",",$tpart);
	query("DELETE FROM reponses WHERE message_id IN ($lpart)");
	query("DELETE FROM demandes WHERE message_id IN ($lpart)");
	}
}	

function purge_rep($liste) {
$t=array_chunk($liste,100);
foreach($t as $tpart) {
	//print_r($tpart);
	$lpart=implode(",",$tpart);
	query("DELETE FROM reponses WHERE reponse_id IN ($lpart)");
	}
}	


//Recherche si la demande est active en fonction des renseignements obtenus
function active_longue() {
global  $message_id,$eleve_id,$item_id,$disc_id,$age,
		$nbnon,$obtenue,$active,$longue,
		$nbj_vie_demande,$nb_validations,$nb_max_refus,$profslongs,
		$taccord,
		$MODULE;
$active=0;$longue=0;
if ($obtenue) return; 
if ($age<=$nbj_vie_demande) {
	if ($nbnon<$nb_max_refus || $nb_max_refus==0) $active=1;
	//parla("age=$age, nbjvie=$nbj_vie_demande, nbmaxrefus=$nb_max_refus, active=$active");
	return; 
	}
if (!$profslongs) return;

/*la demande n'a pas abouti en moins de 15 jours et il y a des profs longs dans l'étab
Seuls les profs longs peuvent apporter leur accord
La demande pourra être "prolongée" (être considérée comme longue) à condition que d'autres profs apportent leur accord.
Actuellement, le bilan est $nboui-$nbnon. Seuls les $nbnon longs peuvent revenir sur leur décision. Supposons qu'il
y en ait $nbnonlongs. Avec ces revirements possibles, on aboutirait à $nboui-$nbnon+$nbnonlongs accords.
Il manque $nb_validations-($nboui-$nbnon+$nbnonlongs).
C'est donc le nombre de profs longs manquant. S'il n'est pas atteint, la demande sera supprimée
*/
if ($MODULE=='Melia') {
	$led=" , lien_eleves_disciplines";
	$conddisc=" AND lien_eleves_disciplines.disc_id=$disc_id AND lien_eleves_disciplines.eleve_id=$eleve_id ";
	}
else {
	$led="";
	$conddisc="";
	}
$reslongs=query("SELECT DISTINCT profs.prof_id, profs.opt_dem1an
				FROM profs,lien_eleves_classes,lien_profs_classes,lpi $led
				WHERE profs.prof_id=lien_profs_classes.prof_id
				AND lien_profs_classes.classe_id=lien_eleves_classes.classe_id
				AND lien_eleves_classes.eleve_id=$eleve_id
				AND lpi.prof_id=profs.prof_id
				AND lpi.item_id=$item_id
				$conddisc
				");
//comptabiliser les accords possibles, en étant un max optimiste
$max=0;
while (list($prof_id,$opt_dem1an)=mysql_fetch_array($reslongs)) {
	//déjà accordé ?
	if (isset($taccord[$prof_id]) && $taccord[$prof_id]) 
		$max++;
	//refusé ?
	elseif (isset($taccord[$prof_id]) && !$taccord[$prof_id]) {
		if  ($opt_dem1an) $max++; 
		else $max--; //ne pourra pas revenir sur son refus
		}
	//le prof n'a pas répondu : seul les profs longs peuvent intervenir
	elseif ($opt_dem1an) 
		$max++; //et on considère de façon optimiste qu'ils répondront OUI
	//else : les autres n'ont rien à dire !
	}
$active=$longue=($max>=$nb_validations)? 1:0;
}
	
	
function updaterdemande() {
global $message_id,$obtenue,$active,$nboui,$nbnon,$longue;

query(" UPDATE demandes 
			SET obtenue=$obtenue,
			 	active=$active,
			 	nboui=$nboui,
			 	nbnon=$nbnon,
			 	longue=$longue
			WHERE message_id=$message_id
			");
}								


//=======================================================================					
/*
Etats possibles des champs obtenu et actif :
	obtenu	1	0	0
	actif	0	0	1
*/
		
$liste_del_rep=array();

print "<h3>Modification de la table demandes</h3><hr />\n";

$resdem=query("	
	SELECT demandes.message_id, demandes.eleve_id, demandes.item_id, demandes.disc_id, demandes.quand, 
			reponses.reponse_id, reponses.prof_id, reponses.accord, resultats.resultat_id, 
			eleves.etab_id
	FROM demandes
	LEFT JOIN reponses ON reponses.message_id = demandes.message_id
	LEFT JOIN resultats ON resultats.item_id = demandes.item_id
						AND resultats.eleve_id = demandes.eleve_id
						AND resultats.disc_id = demandes.disc_id
	, eleves
	WHERE eleves.eleve_id = demandes.eleve_id
	AND obtenue IS NULL
	
	ORDER BY eleves.etab_id, demandes.message_id, reponses.prof_id, reponses.accord
	");

if (!mysql_num_rows($resdem)) {
	print "<p>La table demandes était déjà à jour !</p><br />" ;
	return;
	}
	
alert("Attention : cette modification prend beaucoup de temps (10 à 15 minutes pour un site de 100 000 élèves)");



//recherche des caractéristiques des étabs
$j=0;
$resetab=query("SELECT etab_id,rne, nbj_vie_demande,nb_validations,nb_max_refus,profslongs FROM etablissements");
while ($rowe=mysql_fetch_array($resetab)) {
	$j=$rowe['etab_id'];
	$trne[$j]=$rowe['rne'];
	$tnbj_vie_demande[$j]=$rowe['nbj_vie_demande'];
	$tnb_validations[$j]=$rowe['nb_validations'];
	$tnb_max_refus[$j]=$rowe['nb_max_refus'];
	$tprofslongs[$j]=$rowe['profslongs'];
	}
mysql_free_result($resetab);
	


//obtenu IS NULL est un critère d'élément non encore traité (en cas d'arrêt antérieur du traitement)
$compteur=0;
$etab_id=0;
//on saute les etab_id=0 (ils ne sont qu'au début)
do {
	$row=mysql_fetch_array($resdem);
	}
while (!$row['etab_id']); 

//on tient un $row correct

query("LOCK TABLES 	demandes WRITE, 
					profs READ, lien_eleves_classes READ,
					lien_profs_classes READ, lpi READ, lien_eleves_disciplines READ");
					
//coup de bluff : la plupart des demandes sont telles que obtenue=1, active=0, nboui=1, nbnon=0
query("UPDATE demandes SET obtenue=1, active=0, nboui=1, nbnon=0");

do {
	//une nouvelle demande à traiter
	$message_id=$row['message_id'];
	$compteur++;
	if (($compteur % 1000)==0) {
		echo $compteur,' - ';
		superflush();
		if (($compteur % 10000)==0) voircetendroit();
		}

	//traiter les données constantes pour un même message_id : etab_id, resultat_id, quand, disc_id, item_id, eleve_id
	//------------------------------------------------------
	//etab_id
	if ($etab_id != $row['etab_id']) {
		$etab_id=$row['etab_id'];
		$rne=$trne[$etab_id];
		$nbj_vie_demande=$tnbj_vie_demande[$etab_id];
		$nb_validations=$tnb_validations[$etab_id];
		$nb_max_refus=$tnb_max_refus[$etab_id];
		$profslongs=$tprofslongs[$etab_id];
		}
	$resultat_id=$row['resultat_id'];
	$obtenue = ($resultat_id==NULL)? 0:1; 

	//quand
	$age=(int) ((strtotime("now")-strtotime($row['quand']))/86400);
	//disc_id, item_id, eleve_id	
	$disc_id	=$row['disc_id'];
	$item_id	=$row['item_id'];
	$eleve_id	=$row['eleve_id'];

	$taccord=array(); // $taccord[prof_id]=0 ou 1

	//traiter tous les message_id de même valeur (ils se suivent)
	do {
		$prof_id	=$row['prof_id'];
		$reponse_id	=$row['reponse_id'];
				
		if ($reponse_id!=NULL && $prof_id!=NULL) { //une réponse trouvée pour la demande
			$accord=$row['accord'];
			if (isset($taccord[$prof_id])) {
				//il existait une autre réponse du même prof. On peut avoir 0 0, 0,1, 1,0 1,1
				//la seule succession normale de 2 réponses étant 0,1
				if ($taccord[$prof_id]==0 && $accord==1) { //NON suivi de OUI : c'est OUI !
					$taccord[$prof_id]=1; //on rectifie : le NON ne compte plus
					}
				else { //réponse doublon (00 ou 11) ou incohérente (10)
					$liste_del_rep[]=$reponse_id;
					}
				}
			else $taccord[$prof_id]=$accord;
			}	
		$row=mysql_fetch_array($resdem);
		}
	while ($row && $row['message_id']==$message_id);
	
	//on vient de finir de traiter une demande. On conclut 
	$tcompte=array_count_values($taccord);
	if (isset($tcompte[1])) $nboui=$tcompte[1]; else $nboui=0;
	if (isset($tcompte[0])) $nbnon=$tcompte[0]; else $nbnon=0;
	$bilan=$nboui-$nbnon;
	
	active_longue();

	if (!$obtenue || $active || $nboui!=1 || $nbnon || $longue) 
		updaterdemande();
		}
while ($row);

query("UNLOCK TABLES");
		
$s=pluriel($compteur);
print "<h2>$compteur demande$s traitée$s</h2>";	

purge_rep($liste_del_rep);

	

?>