<?php
//Version d'origine : 5.0.x
//Version cible : 5.1.0
//
//


superflush();
voircetendroit();

//Pour création de tables MYISAM
$enginemysql=get_enginemysql();

//___________________________________________________________________

//   Ancien champ éventuel stockant les disciplines validatrices supprimé, ce sera dans la table lien_result_disc
//___________________________________________________________________

if (champ_dans_table('disc_valid', 'resultats', $db))
{
    query("ALTER TABLE `resultats` DROP disc_valid");
}

//___________________________________________________________________

//   table des témoins de la validation et champs des voisins
//___________________________________________________________________

if (!table_dans_base('temoins', $db))
	{
    print "<br>Ajout de la table 'temoins' pour stockage des témoins (profs validateurs) : ";
    $ok=query("CREATE TABLE temoins (temoin_id INTEGER NOT NULL AUTO_INCREMENT,
    nom VARCHAR(30),prenom VARCHAR(25),civil ENUM('M.','Mme','Mlle'),
    disc_id INTEGER NOT NULL,etab_id INTEGER,PRIMARY KEY (temoin_id)) $enginemysql ");
    if ($ok) print "OK<br>";
    
  if (!champ_dans_table('temoin_id', 'profs', $db)) {
    print "<br>Ajout du champ nécessaire vers la table témoins<br>";
    query("ALTER TABLE `profs` ADD `temoin_id` INT NOT NULL ");
	}
	
//___________________________________________________________________

//   Pré-remplissage de la table témoins
//___________________________________________________________________

  set_time_limit(0);

  print "<br/><b>Remplissage de la table 'temoins' pour les profs </b>: patience c'est un peu long (15 sec pour 7000 profs) ! <br/>";
  superflush();superflush();
  $sqltemoins="SELECT prof_id, nom, prenom, civil, disc_id, etab_id FROM profs";
  $restemoins=query($sqltemoins);
  $cpt=0;

  print "Nombre d'enregistrements à écrire : ".mysql_num_rows($restemoins)."<br />";
  
  query("LOCK TABLES temoins WRITE, profs WRITE");
  
  while (list($prid, $nom, $pre, $ci, $di, $et)=mysql_fetch_array($restemoins)) {
	//On stocke dans la table temoins, ça pourra toujours servir
	if (++$cpt % 1000 ==0) {
		print "$cpt - ";
		superflush();
		}
	$nom=addslashes($nom);
	$pre=addslashes($pre);
	query("INSERT INTO temoins SET nom='$nom', prenom='$pre', civil='$ci', disc_id=$di, etab_id=$et");
	$temoin_id=mysql_insert_id();
	query("UPDATE profs SET temoin_id=$temoin_id WHERE prof_id=$prid");
	}

 query("UNLOCK tables"); 	
  print "<br />";
	
}  // Fin table temoins



//___________________________________________________________________

//   table des liens résultats-disciplines lrt
//___________________________________________________________________

if (!table_dans_base('lrt', $db))
{
    print "<br><b>Ajout de la table 'lrt'</b> pour stockage liens résultats - témoins : ";
    $ok=query("CREATE TABLE lrt (resultat_id INTEGER NOT NULL,temoin_id INTEGER NOT NULL,quand DATETIME,
    		UNIQUE KEY ix_rt(resultat_id, temoin_id)) $enginemysql");
    if ($ok) print "OK<br />";
    
//___________________________________________________________________

//   Pré-remplissage de la table lrt
//___________________________________________________________________    
  print "<br><b>Remplissage de la table 'lrt' </b>pour stockage disciplines validatrices : patience c'est LONG (4 mn pour 400 000 résultats)! <br />";
  //alert("Attention : ce remplissage prend du temps (env 10 minutes pour 400 000 résultats).\n Patientez !");
  superflush();
  	
  $sqllrt="SELECT res.resultat_id, profs.temoin_id, rep.quand
	FROM resultats as res, demandes as dem , reponses as rep,  profs  
	WHERE res.eleve_id=dem.eleve_id AND res.item_id=dem.item_id
	AND res.disc_id=dem.disc_id AND dem.obtenue=1
	AND dem.message_id=rep.message_id AND rep.accord=1
	AND rep.prof_id=profs.prof_id";
  $reslrt=query($sqllrt);
  print "Nombre d'enregistrements à écrire : ".mysql_num_rows($reslrt)."<br />";
  superflush();
  $cpt=0;
  query("LOCK TABLES lrt WRITE");
  while (list($rid, $tem, $quandrep)=mysql_fetch_array($reslrt)) {
	if (++$cpt % 1000 ==0) {
		print "$cpt - ";
		superflush();
		if ($cpt % 10000) voircetendroit();
		}
	query("INSERT IGNORE INTO lrt SET resultat_id=$rid, temoin_id=$tem, quand='$quandrep'");
	}
  query("UNLOCK TABLES");
  print "<br />";
  superflush();    
} //Fin table lrt


?>